function [n1Pic n2Pic] = addNoise(picFile, picFormat)

pic = readPic(picFile, picFormat);
[I J] = size(pic);

% adding normal noise
err = normrnd(0, 0.025, I, J);
n1Pic = pic + err;
n1Pic = n1Pic .* (n1Pic <= 1) + (n1Pic > 1); % set all pixels larger then 1 to 1
n1Pic = n1Pic .* (n1Pic >= 0); % set all pixels smaller then 0 to 0
imwrite(n1Pic, [picFile 'n1.' picFormat]);

% adding salt & pepper noise
err = unifrnd(0, 1, I, J);
n2Pic = pic;
n2Pic = n2Pic .* (err >= 0.025); % set 0.1 from the pixels to 0;
n2Pic = n2Pic .* (err <= 0.975) + (err > 0.975);
imwrite(n2Pic, [picFile 'n2.' picFormat]);


