
%   this function finds the center of each cluster
%   if find the all cluster center in the simplest way, just find the mean
%   of all the pixels with the same label, and then calls findNewCenter to
%   find the centers more accurately.

function clustersCenters = findCenters(labels, numTests)

[I J] = size(labels);
numClusters = max(max(labels));
clustersCenters = zeros(numClusters, 3);
counters = zeros(1, numClusters);

for( i = 1 : I )  
    for ( j = 1 : J )
        clusterNum = labels(i, j);
        counters(clusterNum) = counters(clusterNum) + 1;
        clustersCenters( clusterNum, : ) = clustersCenters( clusterNum, : ) + [i, j, 0];
    end
end

for  (i = 1 : numClusters )
    clustersCenters(i, :) = [round(clustersCenters(i, 1:2) / counters(i)) i];
end

for  (i = 1 : numClusters )
    [clustersCenters(i, 2) clustersCenters(i, 1)] = findNewCenter(labels, clustersCenters(i, 2), clustersCenters(i, 1), clustersCenters(i, 3), numTests);%, h );
end