
%   this function uses findSymmeries outpur and check for every center if
%   all the points around it, have the same distance, or differ by Tround.

function [radiuses, circles, centers] = findCircles( allRadiuses, allSymmetries, allCenters,  numTests, Tround)

[clustersNum numAngles] = size(allRadiuses);
[I J] = size(allSymmetries);
clustersNum = size(allCenters, 1);
centers = [];
radiuses = [];
circles = ones(I, J);

for ( p = 1 : clustersNum )
    maxi = max(allRadiuses(p, :));
    mini = min(allRadiuses(p, :));
    if ( maxi-mini <= Tround )
        radius = mean(allRadiuses(p, :));%(maxi+mini) / 2;
        radiuses = [radiuses radius];
        centers = [centers; allCenters(p, :)];
        k = 1;
        for ( angle = 0 : pi/numTests : 2*pi )
            newX = allCenters(p, 1) + round(radius*sin(angle));
            newY = allCenters(p, 2) + round(radius*cos(angle));
            if ( newX >= 1 && newX <= I && newY >= 1 && newY < J )
                circles(newY, newX) = 0;
            end
        end
    end % if
end % for p
