
%   in the mean shift algorithm, this is the function that gives every point
%   it label.
%   it uses k nearest nieghbos algorithm (with k = 1), and T1 define how
%   much the color distance is effecting the total distance (line 74)

function labels = kNearest ( pic1, centers, T1 )
global pic;
global labels;
global labeledPoints;

pic = pic1;
[I J] = size(pic);
[p, tmp] = size(centers);
labels = zeros(I, J);
labeledPoints = [];

for ( i = 1 : p )
    pointIndex = centers(i, :); 
    labels( pointIndex(1), pointIndex(2) ) = i;
    labeledPoints = [labeledPoints; centers(i,:)];
end

flag = 1;
clusterIndex = 1;
counter = 0;
while (flag == 1 )
    flag = 0;
    mini = Inf;
    minIndex = 0;
    
    [n, tmp] = size(labeledPoints);
    k = 1;
    for ( k1 = 1 : n )
        ij = labeledPoints(k, :);
        [ pointIndex dist fRemoved] = getNearestUnlabeledNeihbor ( ij(1), ij(2), T1, k );
        if ( fRemoved == 0 )
            k = k + 1;
        end
        if ( dist < mini )
            flag = 1;
            mini = dist;
            minIndex = pointIndex;
            clusterIndex = labels(ij(1), ij(2));
        end
    end
    
    if ( flag == 1 )
        counter = counter+1;
        labels(minIndex.i, minIndex.j) = clusterIndex;
        labeledPoints = [labeledPoints; minIndex.i, minIndex.j];
    end
end %while


%returns the index and distance to the nearest unlabeled neihbor to the
%point i, or zero in pointIndex if all points are labeled
function [ pointIndex, minDist, fRemoved ] = getNearestUnlabeledNeihbor (l, m, T1, k )% pic, labels, l, m, T1 )
global pic;
global labels;
global labeledPoints;

[I J] = size(pic);
minDist = Inf;
pointIndex.i = 0;
flag = 0;
[sz tmp] = size(labeledPoints);
fRemoved = 0;

for ( i = l-1 : l+1 )
    for  (j = m-1 : m+1 )
        if( (i ~= l || j ~= m) && i >=1 && i <= I && j >= 1 && j <= J )
            if ( labels(i, j) == 0 )
                flag = 1;
                dist = distance( [l, m, T1*pic(l, m)], [i, j, T1*pic(i, j)] );
                if ( dist < minDist )
                    minDist = dist;
                    pointIndex.i = i;
                    pointIndex.j = j;
                end
            end
        end
    end
end

if ( flag == 0)
    labeledPoints = [labeledPoints(1:k-1, :); labeledPoints(k+1:sz, :)];
    fRemoved = 1;
end
