
%   the main function

%   get only the picture name and format, and run the meanShift algorithm
%   or load its output from earlier run, find all the symmetries shapes and
%   the circles, and plot the centers of the circles as blue '*', and the
%   circles themselves as a circles of red '.'

function run( picFile, picFormat )

flagSave = 0;
if ( nargin < 2 )
    flagSave = 1;
end

% mean shift parameters
T1 = 255;           % how much the color distance will effect the total distance
T2 = 0.1;           % what the color different between two cluster candidates
h = 3;              % the sphere radius
perturbSize = 1;    % the size of the change to be given to the cluster centers
m = 64;             % the num of points in the sample set

if ( flagSave == 0 )
    [pic, labels, centers] = meanShift(picFile, picFormat, T1, T2, h, perturbSize, m);
else
    %I can load the meanShift resaults, instea-d of run the meanShift again
    load([picFile, '.mat']); 
end
imshow(pic)
plotClusters(labels, centers);

% parameters
numTests = 50;      % how much point will be check in a pi radians to see if the shape is symmetric
Tcount = 0.9;       % how much point from te total test will be symmetric
Tround = 4;         % when looking for a circle how much the largest radius is larger then the smallest one

edges = findEdge( labels );
figure
imshow(edges)

clustersCenters = findCenters(labels, numTests);

[allRadiuses allSymmetries allCenters] = findSymmetries( clustersCenters, edges, labels, numTests, Tcount);
% show the symmetric shapes
figure;
imshow(pic);
hold on

cenNum = size(allCenters, 1);
for ( i = 1 : cenNum )
    x = allCenters(i, 1);
    y = allCenters(i, 2);
    plot(x, y, '*b');
end

[I J] = size(allSymmetries);
points = [];
for ( i = 1 : I )
    for ( j = 1 : J )
        if ( allSymmetries(i, j) == 0 )
            points = [points; [j i]];
        end
    end
end
plot(points(:, 1), points(:, 2), '.r');

hold off

[radiuses circles centers] = findCircles( allRadiuses, allSymmetries, allCenters,  numTests, Tround );
% show the circles
figure;
imshow(pic);
hold on

cenNum = size(centers, 1);
for ( i = 1 : cenNum )
    x = centers(i, 1);
    y = centers(i, 2);
    plot(x, y, '*b');
end

[I J] = size(circles);
points = [];
for ( i = 1 : I )
    for ( j = 1 : J )
        if ( circles(i, j) == 0 )
            points = [points; [j i]];
        end
    end
end
plot(points(:, 1), points(:, 2), '.r');

hold off