
%   this function checks if the distance in color between every two centers
%   is larger the T2 ( T2 in [0, 1] )

function centers = validateCenters( tempCenters, h, pic, T2)

[p dim] = size(tempCenters);

flags = zeros(1, p);
for (i = 1 : p-1)
    for (j = i+1 : p)
        if( flags(i) == 0 && flags(j) == 0 )
            t1 = round(tempCenters(i, :));
            val1 = pic( t1(1), t1(2));
            t2 = round(tempCenters(j, :));
            val2 = pic(t2(1), t2(2));
            
            if( abs(val1 - val2) <= T2 )
                flags(j) = 1;
            end 
        end %if

    end % for - j
end % for - i

flagsCount = p - sum(flags);

centers = zeros(flagsCount, dim);
j = 1;
for (i = 1 : p)
    if (flags(i) == 0)
        centers(j, :) = tempCenters(i,:);
        j = j+1;
    end
end
